<?php
/**
 * @license © 2018, Vladimír Hans, BSD licence http://opensource.org/licenses/bsd-license.php
 */
namespace ServiceModule;

class BasePresenter extends \Nette\Application\UI\Presenter{
	
	protected $httpResponse;
	protected $container;
	
	public function __construct() {
		parent::__construct();
	}
	
	public function startUp(){
		parent::startup();
	}
	
	
	protected function sendUnauthorized(){
		$this->httpResponse->setCode(\Nette\Http\Response::S401_UNAUTHORIZED);
		$response['id'] = "null";
		$this->sendResponse(new \Nette\Application\Responses\JsonResponse($response));
	}
	
	protected function sendForbidden(){
		$this->httpResponse->setCode(\Nette\Http\Response::S403_FORBIDDEN);
		$response['id'] = "null";
		$this->sendResponse(new \Nette\Application\Responses\JsonResponse($response));
	}
	
	protected function sendExceptationFailed(){
		$this->httpResponse->setCode(\Nette\Http\Response::S417_EXPECTATION_FAILED);
		$response['id'] = "null";
		$this->sendResponse(new \Nette\Application\Responses\JsonResponse($response));
	}
	
	protected function sendPaymentRequired(){
		$this->httpResponse->setCode(\Nette\Http\Response::S402_PAYMENT_REQUIRED);
		$response['id'] = "null";
		$this->sendResponse(new \Nette\Application\Responses\JsonResponse($response));
	}
	
	protected function sendNotAccetable(){
		$this->httpResponse->setCode(\Nette\Http\Response::S406_NOT_ACCEPTABLE);
		$response['id'] = "null";
		$this->sendResponse(new \Nette\Application\Responses\JsonResponse($response));
		
	}
	
	protected function login($input){
		if(isset($input['user']) && isset($input['password'])){
			try{
				$user = $this->getUser();
				$user->login($input['user'], $input['password']);
				return TRUE;
			}catch (Nette\Security\AuthenticationException $e) {
				$this->sendUnauthorized();
				return FALSE;
			}
		}else{
			$this->sendForbidden();
			return FALSE;
		}
	}
}

