<?php
/**
 * @license © 2018, Vladimír Hans, BSD licence http://opensource.org/licenses/bsd-license.php
 */
namespace ServiceModule;

class CountnewerPresenter extends \ServiceModule\BasePresenter{
	
	private $mainRepository;
	
	public function __construct(\Nette\DI\Container $container) {
		\Tracy\Debugger::enable(TRUE);
		parent::__construct();
		$this->container = $container;
		$this->httpResponse = $this->container->getByType('\Nette\Http\Response');
	}
	
	public function startup() {
		parent::startup();
		$this->mainRepository = $this->context->getService("taxonRepository");
	}
	
	/**
	 * Get JSON of families
	 * @param type $type Type of output
	 */
	public function actionReadAll(){
		$params = $this->getRequest()->getParameter('query');
		if(isset($params['date'])){
			$count = $this->mainRepository->getCountNewer($params['date']);
			$res = array("count"=>$count);
			$this->sendResponse(new \Nette\Application\Responses\JsonResponse($res));
		}else{
			$this->sendPaymentRequired();
		}	

	}
}