<?php
/**
 * @license © 2018, Vladimír Hans, BSD licence http://opensource.org/licenses/bsd-license.php
 */
namespace ServiceModule;

class FamilyPresenter extends \ServiceModule\BasePresenter{
	
	private $familyRepository;
	
	public function __construct(\Nette\DI\Container $container) {
		\Tracy\Debugger::enable(false);
		parent::__construct();
		$this->container = $container;
		$this->httpResponse = $this->container->getByType('\Nette\Http\Response');
	}
	
	public function startup() {
		parent::startup();
		$this->familyRepository = $this->context->getService("familyRepository");
	}
	
	/**
	 * Get JSON of families
	 * @param type $type Type of output
	 */
	public function actionRead(){
		$params = $this->getRequest()->getParameter('query');
		if(isset($params['sample'])){
			$sample = $params['sample'].'%';
			$data= $this->familyRepository->getIdNameArray($sample);
			$res = NULL;
			if(count($data)>0){
				foreach($data as $family){
				$res[] = array($family["id"]=>$family["name"]);

				}
			}
			if($res){
				$this->sendResponse(new \Nette\Application\Responses\JsonResponse($res));
			}
		}else{
			$this->sendPaymentRequired();
		}
	}
}