<?php
/**
 * @license © 2018, Vladimír Hans, BSD licence http://opensource.org/licenses/bsd-license.php
 */
namespace ServiceModule;

class LastupdatePresenter extends \ServiceModule\BasePresenter{
	
	private $mainRepository;
	
	public function __construct(\Nette\DI\Container $container) {
		\Tracy\Debugger::enable(TRUE);
		parent::__construct();
		$this->container = $container;
		$this->httpResponse = $this->container->getByType('\Nette\Http\Response');
	}
	
	public function startup() {
		parent::startup();
		$this->mainRepository = $this->context->getService("taxonRepository");
	}
	
	/**
	 * Get JSON of families
	 * @param type $type Type of output
	 */
	public function actionReadAll(){
		$date= $this->mainRepository->getLastUpdate();
		$date = str_replace(" ","T",$date."Z");
		$res = array("date"=>$date);
		$this->sendResponse(new \Nette\Application\Responses\JsonResponse($res));
			

	}
}