<?php
/**
 * @license © 2020, Vladimír Hans, BSD licence http://opensource.org/licenses/bsd-license.php
 */
namespace ServiceModule;

class NamePresenter extends \ServiceModule\BasePresenter{
	
	private $mainRepository;
	
	public function __construct(\Nette\DI\Container $container) {
		\Tracy\Debugger::enable(TRUE);
		parent::__construct();
		$this->container = $container;
		$this->httpResponse = $this->container->getByType('\Nette\Http\Response');
	}
	
	public function startup() {
		parent::startup();
		$this->mainRepository = $this->context->getService("systemSettingsRepository");
	}
	
	/**
	 * Get JSON of families
	 * @param type $type Type of output
	 */
	public function actionReadAll(){
		$name= $this->mainRepository->getName();
		$res = array("name"=>$name);
		$this->sendResponse(new \Nette\Application\Responses\JsonResponse($res));
	}
}