<?php
/**
 * @license © 2018, Vladimír Hans, BSD licence http://opensource.org/licenses/bsd-license.php
 */
namespace ServiceModule;

class TaxonPresenter extends \ServiceModule\BasePresenter{
	
	private $viewRepository;
	
	public function __construct(\Nette\DI\Container $container) {
		\Tracy\Debugger::enable(false);
		parent::__construct();
		$this->container = $container;
		$this->httpResponse = $this->container->getByType('\Nette\Http\Response');
	}
	
	public function startup() {
		parent::startup();
		$this->viewRepository = $this->context->getService("viewtaxonRepository");
	}
	
	/**
	 * Get JSON of families
	 * @param type $type Type of output
	 */
	public function actionRead(){
		$params = $this->getRequest()->getParameter('query');
		if(isset($params['sample'])){
			$sample = $params['sample'].'%';
			$sample = str_replace(" ", "% ", $sample);
			$data= $this->viewRepository->getIdNameArray($sample);
			$res = NULL;
			if($data){
				foreach($data as $taxon){
				$res[$taxon["id"]] = $taxon["name"];
				}
			}
			if($res){
				$this->sendResponse(new \Nette\Application\Responses\JsonResponse($res));
			}
		}else{
			$this->sendPaymentRequired();
		}
	}
}