<?php

/**
 * @license © 2016, Vladimír Hans, BSD licence http://opensource.org/licenses/bsd-license.php
 */


use Nette\Security;


/**
 * Users authenticator.
 */
class Authenticator  implements Security\IAuthenticator
{
	use Nette\SmartObject;
    private $database;

    public function __construct(Nette\Database\Context $database){
        $this->database = $database;
    }
    
    
    public function authenticate(array $credentials) {
	
	list($username, $password) = $credentials;
        $row = $this->database->table('taxony_tblUsers')
            ->where('cUserName', $username)->fetch();
        
	if (!$row) {
            throw new Security\AuthenticationException('Chybné jméno', self::IDENTITY_NOT_FOUND);
        }

	if ($row->cPassword != hash('sha256', $username."$".(strlen($password) * strlen($username))."&".$password."#".(strlen($password) + strlen($username)))) {
            throw new Security\AuthenticationException('Chybné heslo', self::INVALID_CREDENTIAL);
	}

	return new Security\Identity($row->cId);
	
    }

}
