<?php

class SystemSettingsRepository
{
	use Nette\SmartObject;
	
	private $mapper;

	public function __construct(SystemSettingsMapper $mapper){
		$this->mapper = $mapper;
	}
	
	public function delete(){
		$this->mapper->delete();
	}
	
	public function save($data){
		$res = true;
		foreach($data as $row){
			$res *= $this->mapper->save($row);
		}
		if($res ==1 ){
			return true;
		}else{
			return false;
		}
	}
	
	public function getName(){
		return $this->getSysValue('name', NULL);
	}
	
	private function getSysValue($value,$defval){
		$items = $this->mapper->findBy(array('column'=>'key','value'=>$value));
		$result = $defval;
		if($items){
			foreach($items as $item){
				$result = $item->value;
			}
		}
		return $result;
	}
	
	public function getId($key){
		$items = $this->mapper->findBy(array('column'=>'key','value'=>$key));
		$id = null;
		if($items){
			foreach($items as $item){
				$id = $item->getId();
			}
		}
		return $id;
	}
}