<?php

class ViewtaxonRepository
{
	use Nette\SmartObject;
    private $mapper;
    
    public function __construct(ViewtaxonMapper $mapper) {
        $this->mapper = $mapper;
    }
    
    public function getDataSource($length, $offset,$order=NULL,$where = NULL){
        return $this->mapper->getAll($length, $offset, $order, $where);
    }
    
    public function getCountAll($where = NULL){
        return $this->mapper->getCountAll($where);
    }
    
    public function findById($id){
        $items = $this->mapper->getAll(10,0,NULL,array('id' => $id));
        if($items){
            return $items[0];
        }else{
            return NULL;
        }
    }
	
	public function getIdNameArray($sample){
		$items = $this->mapper->getAll(7000, 0,array('taxon'=>'ASC'), array('taxon'=>$sample, 'valid'=>1));
		$data= null;
		if($items){
			foreach($items as $item){
				$data[] = array('id'=>$item->getId(),'name'=>$item->taxon);
			}
		}
		return $data;
	}
}
