<?php

use Nette\Application\UI\Form;

class FamilyPresenter extends BasePresenter{
	private $familyRepository;
	private $userRepository;
	private $taxonRepository;
	
	public function startup(){
		parent::startup();
		parent::__construct();
		$this->familyRepository = $this->context->getService('familyRepository');
		$this->userRepository = $this->context->getService('userRepository');
		$this->taxonRepository = $this->context->getService('taxonRepository');
	}
	
		public function actionEdit(){
        If($this->user->isLoggedIn() == FALSE){
            $this->redirect('Homepage:default');
        }
    }
    
    public function actionDefault(){
        If($this->user->isLoggedIn() == FALSE){
            $this->redirect('Homepage:default');
        }
    }
	
	public function renderDefault(){
		$items = $this->familyRepository->getDAtaSource(10000,0,array('name'=>'ASC'));
		$this->template->items = $items;
	}	
	
	public function renderEdit($id){
        If($id){
            $headline = "Upravit čeleď";
        }else{
            $headline = "Nová čeleď";
        }
        $this->template->headline = $headline;
    }
	
	public function createComponentEditForm(){
		$id = $this->getParameter('id');
		$defaultValue = $this->getDefaultFormValue($id);
		$form = new Form();
		$form->addText('id','ID');
		$form->addText('name','Čeleď');
		$form->addText('user', "Přidal")
				->setDisabled();
		$form->addText('change', "Změnil")
				->setDisabled();
		$form->addText('timeadd',"Přidáno")
				->setDisabled();
		$form->addText('timeedit','Změněno')
				->setDisabled();
		$form->addSubmit('send','Uložit');
        $form->onSuccess[] = (array($this,'processEditForm'));
		$form->setDefaults(array(
			'id'=>$defaultValue["id"],
			'name'=>$defaultValue['name'],
			'user'=>$defaultValue['user'],
			'change'=>$defaultValue['change'],
			'timeadd'=>$defaultValue['add'],
			'timeedit'=>$defaultValue['edit']
		));
		return $form;
		
	}
	
	public function processEditForm(Form $form){
		if($this->user->isLoggedIn()){
			$values = $form->getValues();
			//$this->flashMessage('<img id="flash-icon" src="../images/dialog-information.png"><span class="flash-text">Čeleď byla uložena</span> <img id="flash-cancel" src="../images/dialog-close.png">','info');
			$this->flashMessage('Čeleď byla uložena','info');
			$this->familyRepository->save($this->getFormValue($values));
			if($values->id){
				$this->redirect('Family:default');
			}else{
				$this->redirect('Family:edit');
			}
		}else{
			//$this->flashMessage('<img id="flash-icon" src="../images/dialog-warning.png"><span class="flash-text">Neoprávněný přístup</span> <img id="flash-cancel" src="../images/dialog-close.png">','error');
			$this->flashMessage('Neoprávněný přístup','error');
		}
	}
	
	private function getDefaultFormValue($id){
		$values = NULL;
		if($id){
			$item = $this->familyRepository->findById($id);
			$creatorItem = $this->userRepository->findById($item->userid);
			$editorItem = $this->userRepository->findById($item->change);
			$values['id'] = $item->getId();
			$values['name'] = $item->name;
			$values['user'] = $creatorItem->surname." ".$creatorItem->firstname;
			$values['change'] = $editorItem->surname." ".$editorItem->firstname;
			$values['add'] = $item->getAddDate();
			$values['edit'] = $item->getEditDate();
		} else {
			$values['id'] = NULL;
			$values['name'] = NULL;
			$values['user'] = NULL;
			$values['change'] = NULL;
			$values['add'] = NULL;
			$values['edit'] = NULL;
        }
        return $values;
    }
	
	private function getFormValue($formvalues){
		if($formvalues->id){
			$value['id']= $formvalues['id'];
		}else{
			$value['id']= NULL;
		}
		$value['name'] = $formvalues['name'];
		$value['edit'] = date('Y-m-d H:i:s');
		if($formvalues->id){
			$item = $this->familyRepository->findById($formvalues->id);
			$value['add'] = $item->getAddDateISO();
			$value['userid'] = $item->userid;;
		}else{
			$value['add'] = date("Y-m-d H:i:s");
			$value['userid'] = $this->user->getId();
		}
		
		$value['change'] = $this->user->getId();
		
		return $value;
	}
	
	public function handleDelete(){
		if($this->user->isLoggedIn()){
			$id = $this->getParameter('id');
			$count = $this->taxonRepository->getCountByFamily($id);
			if($count==0){
				$this->familyRepository->delete($id);
				$this->flashMessage('Čeleď byla smazána','info');
				$this->redirect('Family:default');
			}else{
				$this->flashMessage('Čeleď je použita u '.$count.' taxonů','error');
			}
		}
	}
}