<?php

use Nette\Application\UI\Form;

class SystemsettingsPresenter extends BasePresenter{
	private $systemSettingsRepository;

	public function startup(){
		parent::startup();
		$this->systemSettingsRepository = $this->context->getService('systemSettingsRepository');
	}
	
	public function actionEdit(){
		if($this->user->isLoggedIn() == FALSE){
			$this->redirect('Homepage:default');
		}
	}
	
	public function createComponentSystemEditForm(){
		$form = new Form();
		$form->addHidden('name_id');
		$form->addText('name','Název checklistu');
		$form->addSubmit('submit','Uložit');
		$form->onSuccess[] = array($this, 'processSystemEditForm');
		$form->setDefaults(array(
			'name_id' => $this->systemSettingsRepository->getId('name'),
			'name'=> $this->systemSettingsRepository->getName()
		));
		return $form;
	}
	
	public function processSystemEditForm(Form $form){
		if($this->user->isLoggedIn()){
			$value = $form->getValues();
			$data = $this->getData($value);
			if($this->systemSettingsRepository->save($data) == true){
				$this->flashMessage('<img id="flash-icon" src="./images/dialog-information.png"><span class="flash-text">Nastavení bylo uloženo</span> <img id="flash-cancel" src="'.$this->context->getService('httpRequest')->url->baseUrl.'/images/close16-g.svg">','info');
			}else{
				$this->flashMessage('<img id="flash-icon" src="./images/dialog-error.png"><span class="flash-text">Nastavení nebylo uloženo</span> <img id="flash-cancel" src="'.$this->context->getService('httpRequest')->url->baseUrl.'/images/close16-g.svg">','error');
			}
			$this->redirect('Homepage:default');
		}
	}
	
	public function renderEdit(){
		$this->template->headline = "Nastavení";
	}
	
	private function getData($value){
		$data[] = $this->addData($value['name_id'],'name',$value['name']);
		return $data;
	}
	
	private function addData($id, $key, $value){
		if(strlen($id==0)){
			$id2 = NULL;
		}else{
			$id2 = $id;
		}
		return array('id' => $id2,'key'=>$key,'value'=> $value);
	}
}