<?php
/**
 * @license © 2016, Vladimír Hans, BSD licence http://opensource.org/licenses/bsd-license.php
 */

use Nette\Security;



/**
 * Users authenticator.
 */
class Authenticator extends Nette\Object implements Security\IAuthenticator
{
	/**
	 * @param UserRepository
	 */

	private $repo;

	public function __construct(UserRepository $repo)
	{
		$this->repo = $repo;
	}


	/**
	 * Performs an authentication.
	 * @return Nette\Security\Identity
	 * @throws Nette\Security\AuthenticationException
	 */
	public function authenticate(array $credentials)
	{
		list($username, $password) = $credentials;
		$item = $this->repo->findByUserName($username);

		if (!$item) {
			throw new Security\AuthenticationException('Chybné jméno', self::IDENTITY_NOT_FOUND);
		}

		if ($item->password != hash('sha256', $username."$".(strlen($password) * strlen($username))."&".$password."#".(strlen($password) + strlen($username)))) {
			throw new Security\AuthenticationException('Chybné heslo', self::INVALID_CREDENTIAL);
		}

		return new Security\Identity($item->getId(),$item->role);
	}




}

