<?php
namespace Test;

use Nette,
    Tester,
    Tester\Assert;

$container = require __DIR__ . '/../bootstrap.php';


class DownloadMapperTest extends Tester\TestCase
{
    private $container;
    private $mapper;

    function __construct(Nette\DI\Container $container){
        $this->container = $container;
        $this->mapper = $this->container->getService('downloadMapper');  
    }


    function setUp(){
        \Tester\Environment::lock("db.lock",dirname('TEMP_DIR'));
        \Nette\Database\Helpers::loadFromFile( $this->container->getService('database.default'), __DIR__.'/../initialise_db.sql');
    }
    public function testGetCount(){
        $count = $this->mapper->getCount();
        Assert::equal(10, $count);
    }
    
    public function testGetLast(){
        $last = $this->mapper->getLast();
        Assert::equal('24. 10. 2016 16:52:48', $last);
    }
    
    public function testISDeleteOk(){
        $res = $this->mapper->isDeleteOK('2016-10-24 16:59:59');
        Assert::true($res);
    }
    
    public function testISDeleteOk2(){
        $res = $this->mapper->isDeleteOK('2016-10-23 16:59:59');
        Assert::false($res);
    }
    
    public function testSave(){
        $data['time'] = "2016-10-24 18:20:21";
        $this->mapper->save($data);
        $row = $this->container->getService('database.default')->query('SELECT count(cId) AS count FROM taxony_tblDownload WHERE cTime = ?',$data['time'])->fetch();
        Assert::equal(1, $row['count']);
    }
}
$test = new DownloadMapperTest($container);
$test->run();