<?php
namespace Test;

use Nette,
    Tester,
    Tester\Assert;

require __DIR__."/../../vendor/vendor/autoload.php";

$container = require __DIR__ . '/../bootstrap.php';

class ExportModelTest extends Tester\TestCase{
    private $mapper;
    private $container;
    private $mockista;
    
    public function __construct(Nette\DI\Container $container) {
        $this->container = $container;
        $this->mapper = $this->container->getService("exportModel");
        
    }
    
    public function setUp(){
    }
    
    public function testStart(){
        $this->mockista = new \Mockista\Registry();
        $item1 = $this->mockista->create();
        $item1->expects("getId")->andReturn('test1');
        $item1->genushybridmarker = 'x';
        $item1->genus = 'Genus';
        $item1->infragenericmarker = 'ser.';
        $item1->infragenericep = 'Glandulosi';
        $item1->infragenericauthor = 'infragenauthor';
        $item1->specieshybridmarker = 'x';
        $item1->aggregatmarker = 'agg.';
        $item1->speciesep = 'species';
        $item1->speciesauthor = 'specauthor';
        $item1->infraspecificmarker = 'var';
        $item1->infraspecificep = 'varieta';
        $item1->infraspecificauthor = 'varietaauthor';
        $item1->cultivgroupmarker = 'cgm';
        $item1->cultivmarker = 'cultiv.';
        $item1->cultivname = 'Tristis';
        $item1->czname = 'jmeno';
        $item1->abbrev = 'TesSpec';
        $item1->note = 'note';
        $item1->id_tax = 'test1';
        $item1->add = '2016-10-2 22:22:22';
        
        $item2 = $this->mockista->create();
        $item2->expects("getId")->andReturn('test2');
        $item2->genushybridmarker = 'x';
        $item2->genus = 'Carex';
        $item2->infragenericmarker = 'ser.';
        $item2->infragenericep = 'Corylifolia';
        $item2->infragenericauthor = 'L.';
        $item2->specieshybridmarker = 'x';
        $item2->aggregatmarker = 'agg.';
        $item2->speciesep = 'bohemica';
        $item2->speciesauthor = 'Roberts.';
        $item2->infraspecificmarker = 'var';
        $item2->infraspecificep = 'nigra';
        $item2->infraspecificauthor = 'varietaauthor';
        $item2->cultivgroupmarker = 'CGM';
        $item2->cultivmarker = 'cultiv.';
        $item2->cultivname = 'vulgaris';
        $item2->czname = 'jmeno';
        $item2->abbrev = 'CarBoh';
        $item2->note = 'note2';
        $item2->id_tax = 'test2';
        $item2->add = '2016-10-2 23:03:10';
        

        $collection = array($item1,$item2);
        
        $dir = dirname(__FILE__)."/../../export/";
        $folder = opendir($dir);        
        while ($filename = readdir($folder)){
            if(is_file($dir.'/'.$filename)){
                unlink($dir.$filename);
            }
        }
        $exportfile = "pokus.bz2";
        $this->mapper->setUp($collection,$exportfile);

        $this->mapper->start();
        Assert::true(is_file($dir.'/'.$exportfile));
    }
    
    public function testGetFileName(){
        $res = $this->mapper->getFileName();
        Assert::match("#checklist_[1-3][0-9]-[0,1][0-9]-20[1,2][1-9]-[0-2][0-9]-[0-5][0-9]-[0-5][0-9]_[0-9]{1,3}.bz2#", $res);
    }
}
$test = new ExportModelTest($container);
$test->run();
